"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.PageLink = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _react = _interopRequireWildcard(require("react"));
var _react2 = require("./react");
var _jsxFileName = "/home/builduser/work/299b793a8321398/giza/giza-dashboard-sdk-react/dist/cjs/PageLink.tsx"; // eslint-disable-next-line import/no-extraneous-dependencies
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const PageLink = ({
  destination,
  onClick,
  children,
  ...otherHtmlProps
}) => {
  const sdk = (0, _react2.useDashboard)();
  const [href, setHref] = (0, _react.useState)();
  (0, _react.useEffect)(() => {
    let isEffectStillRelevant = true;
    const urlPromise = sdk.getPageUrl(destination);
    urlPromise.then(url => isEffectStillRelevant && setHref(url));
    return () => {
      isEffectStillRelevant = false;
    };
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [destination]);
  const handleClick = clickEvent => {
    if (onClick) {
      onClick(clickEvent);
    }
    if (!clickEvent.defaultPrevented) {
      clickEvent.preventDefault();
      sdk.navigate(destination);
    }
  };
  return /*#__PURE__*/_react.default.createElement("a", (0, _extends2.default)({}, otherHtmlProps, {
    href: href,
    onClick: handleClick,
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 39,
      columnNumber: 5
    }
  }), children);
};
exports.PageLink = PageLink;
//# sourceMappingURL=PageLink.js.map