"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.withDashboard = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _react = _interopRequireWildcard(require("react"));
var _sdkReact = require("@wix/sdk-react");
var _dashboard = require("@wix/dashboard");
var _jsxFileName = "/home/builduser/work/299b793a8321398/giza/giza-dashboard-sdk-react/dist/cjs/withDashboard.tsx"; // eslint-disable-next-line import/no-extraneous-dependencies
// eslint-disable-next-line import/no-extraneous-dependencies
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const withDashboard = Component => {
  return ownPropsWithHost => {
    const {
      host: maybeGivenHost,
      ...ownProps
    } = ownPropsWithHost;
    const {
      host,
      props: hostProps
    } = useHostAndProps(ownPropsWithHost.host);
    const [auth] = (0, _react.useState)(_dashboard.dashboard.auth);
    if (!host || !hostProps) {
      return null;
    }
    return /*#__PURE__*/_react.default.createElement(_sdkReact.WixProvider, {
      host: host,
      auth: auth,
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 27,
        columnNumber: 7
      }
    }, /*#__PURE__*/_react.default.createElement(Component, (0, _extends2.default)({}, hostProps, ownProps, {
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 28,
        columnNumber: 9
      }
    })));
  };
};
exports.withDashboard = withDashboard;
const useHostAndProps = localHost => {
  const [remoteHost, setRemoteHost] = (0, _react.useState)();
  const [remoteHostProps, setRemoteHostProps] = (0, _react.useState)();
  (0, _react.useEffect)(() => {
    if (localHost) {
      return;
    }
    const _remoteHost = _dashboard.dashboard.host();
    setRemoteHost(_remoteHost);
    const observeState = _remoteHost.channel.observeState; // casting is needed because typescript couldn't handle it by itself
    const observeResult = observeState(newObservedProps => {
      setRemoteHostProps(newObservedProps);
    });
    const cleanup = async () => {
      setRemoteHost(undefined);
      setRemoteHostProps(undefined);
      (await observeResult).disconnect();
      _remoteHost.close();
    };
    return () => {
      cleanup();
    };
  }, [localHost]);
  return localHost ? {
    host: localHost,
    props: {}
  } : {
    host: remoteHost,
    props: remoteHostProps
  };
};
//# sourceMappingURL=withDashboard.js.map