import { EnvironmentState } from '@wix/dashboard';
import type { ReactSDK, UseContainerMenuItems, UseContainerWidgets, UseWidget } from './types';
export { ReactSDK };
export * from '@wix/dashboard';
export { withDashboard } from './withDashboard';
export { PageLink } from './PageLink';
/**
 * Returns an object with methods to interact with the dashboard.
 */
export declare const useDashboard: () => ReactSDK;
export declare const useWidget: UseWidget;
export declare const useContainerWidgets: UseContainerWidgets;
export declare const useContainerMenuItems: UseContainerMenuItems;
export declare const usePageLocation: () => EnvironmentState["pageLocation"];
export declare const useLanguage: () => EnvironmentState["language"];
//# sourceMappingURL=react.d.ts.map